<?php

namespace Drupal\chemistry_defaults;

use Drupal\Core\Block\BlockManagerInterface;
use Drupal\Core\DependencyInjection\ContainerInjectionInterface;
use Drupal\user\PermissionHandlerInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Permissions callback handler.
 */
class ChemistryDefaultsPermissions implements ContainerInjectionInterface {

  /**
   * {@inheritdoc}
   */
  public function __construct(
    protected PermissionHandlerInterface $permissionHandler,
    protected BlockManagerInterface $blockManager,
  ) {
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('user.permissions'),
      $container->get('plugin.manager.block'),
    );
  }

  /**
   * Ensure block_content permission is available..
   *
   * See https://www.drupal.org/project/block_permissions/issues/3457662 We
   * want to grant content editors the permission to manage block_content
   * blocks, the permission is not included in those generated by
   * block_permissions until a content block has been created. We thus make
   * sure it is present. I am happy with the implicit assumption that the
   * block_content module is installed on our sites.
   *
   * @return array
   *   Array of permissions.
   */
  public function permissions() {

    $definitions = $this->blockManager->getDefinitions();
    $providers = [];
    // N.B. deliberately following the same approach as block_permissions to
    // produce the list of block providers.
    foreach ($definitions as $definition) {
      $providers[$definition['provider']] = $definition['provider'];
    }

    $permissions = [];

    $block_content_permission = 'administer blocks provided by block_content';

    if (!array_key_exists('block_content', $providers)) {
      $permissions[$block_content_permission] = [
        'title' => 'Manage blocks provided by block_content',
        'description' => 'Placeholder from chemistry_defaults',
      ];
      return $permissions;
    }

  }

}
